use binrw::{BinRead, BinWrite, FilePtr64};

use crate::{array_of::ArrayOf, layer::Layer, pen::PenHeader};

#[derive(BinRead, Debug)]
pub struct Header {
    _magic: [u16; 8],
    _unknown_1: [u8; 0x150],
    pub thumbnail: FilePtr64<Thumbnail>,
    pub pens: FilePtr64<PenHeader>,
    _unknown_offset: FilePtr64<()>,
    pub layers: FilePtr64<ArrayOf<Layer>>,
    _unknown_2: [u8; 0x1A8],
}

#[derive(BinRead, BinWrite, Debug)]
pub struct Thumbnail {
    _zeros_1: u32,
    pub dimension_x: u32,
    pub dimension_y: u32,
    _unknown_1: u32, // 0x320?
    _unknown_2: u32, // 0x200001?
    _zeros_2: [u32; 3],

    #[br(count = dimension_x * dimension_y)]
    // pub pixels: Vec<Rgba>, // Takes ~1s longer
    pub pixels: Vec<u32>,
}
